﻿using System;
using System.ComponentModel;
using System.Linq.Expressions;

namespace DemoTelerikSelectionDragnDrop.Model
{
    public class ModelBase : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(string propertyName)
        {
            var propertyChangedEvent = PropertyChanged;
            if (propertyChangedEvent != null)
            {
                propertyChangedEvent(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public void RaisePropertyChanged<T>(Expression<Func<T>> propertyExpression)
        {
            var propertyChangedEvent = PropertyChanged;
            if (propertyChangedEvent != null)
            {
                var body = (MemberExpression)propertyExpression.Body;
                propertyChangedEvent(this, new PropertyChangedEventArgs(body.Member.Name));
            }
        }
    }
}
