﻿using DemoTelerikSelectionDragnDrop.ViewModel;
using System.Windows;
using Telerik.Windows.DragDrop.Behaviors;
using System.Linq;

namespace DemoTelerikSelectionDragnDrop.View.Behaviors
{
    public class ThingsCategoryDragDropBehavior : ListBoxDragDropBehavior
    {
        public static readonly DependencyProperty CategoryProperty = DependencyProperty.Register("Category", typeof(string), typeof(ThingsCategoryDragDropBehavior));

        public string Category
        {
            private get { return (string)GetValue(CategoryProperty); }
            set { SetValue(CategoryProperty, value); }
        }

        public override void Drop(DragDropState state)
        {
            var draggedThing = state.DraggedItems.OfType<ThingViewModel>().FirstOrDefault();
            if (draggedThing != null)
            {
                draggedThing.Category = Category;
            }

            base.Drop(state);
        }

        public override bool CanDrop(DragDropState state)
        {
            return base.CanDrop(state) && state.DraggedItems.OfType<ThingViewModel>().Any();
        }

        public override void DragDropCompleted(DragDropState state)
        {
            base.DragDropCompleted(state);
        }

    }
}
