﻿using System.Windows.Controls;
using System.Windows.Data;
using DemoTelerikSelectionDragnDrop.ViewModel;
using Telerik.Windows.Controls;

namespace DemoTelerikSelectionDragnDrop.View
{
    public partial class MyPane
    {
        private MyPaneViewModel _viewModel;
        public MyPane()
        {
            InitializeComponent();

            _viewModel = new MyPaneViewModel();
            DataContext = _viewModel;
        }

        private void CategoryA_OnFilter(object sender, FilterEventArgs e)
        {
            var thing = e.Item as ThingViewModel;
            e.Accepted = thing != null && thing.Category == "A";
        }

        private void CategoryB_OnFilter(object sender, FilterEventArgs e)
        {
            var thing = e.Item as ThingViewModel;
            e.Accepted = thing != null && thing.Category == "B";
        }

        private void CategoryC_OnFilter(object sender, FilterEventArgs e)
        {
            var thing = e.Item as ThingViewModel;
            e.Accepted = thing != null && thing.Category == "C";
        }

        private bool _isSelectionChangeInProgress;
        private void ListBoxAllThings_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (!_isSelectionChangeInProgress)
            {
                _isSelectionChangeInProgress = true;
                var listBox = sender as RadListBox;
                var newSelectedThing = listBox == null ? null : listBox.SelectedItem as ThingViewModel;

                if (listBox != CategoryAThings) CategoryAThings.SelectionHelper.ClearSelection();
                if (listBox != CategoryBThings) CategoryBThings.SelectionHelper.ClearSelection();
                if (listBox != CategoryCThings) CategoryCThings.SelectionHelper.ClearSelection();

                _isSelectionChangeInProgress = false;

                if (newSelectedThing != null)
                {
                    
                    _viewModel.SelectedThing = newSelectedThing;
                }
            }
        }
    }
}
