﻿using System.Windows.Input;
using DemoTelerikSelectionDragnDrop.Model;
using GalaSoft.MvvmLight.Command;

namespace DemoTelerikSelectionDragnDrop.ViewModel
{
    public class ThingViewModel : GalaSoft.MvvmLight.ViewModelBase
    {
        private readonly Thing _thing;
        private readonly ICommand _setCategoryACommand;

        public ThingViewModel(Thing thing)
        {
            _thing = thing;
            _setCategoryACommand = new RelayCommand(() => Category = "A");
        }

        public string Name
        {
            get { return _thing.Name; }
            set
            {
                if (_thing.Name == value)
                {
                    return;
                }

                _thing.Name = value;
                RaisePropertyChanged("Name");
            }
        }

        public string Category
        {
            get { return _thing.Category; }
            set
            {
                if (_thing.Category == value)
                {
                    return;
                }

                _thing.Category = value;
                RaisePropertyChanged("Category");
            }
        }

        public ICommand SetCategoryACommand
        {
            get { return _setCategoryACommand; }
        }
    }
}
